# Отчёт по лабораторной работе №2

Выполнил: студент гр. ИСЭбд-41 Фомичев Андрей.

Вариант программы 1: Ищет в каталоге `/var/data` файл с самым коротким названием и перекладывает его в `/var/result/data.txt`.

Вариант программы 2: Ищет наименьшее число из файла `/var/data/data.txt` и сохраняет количество таких чисел из последовательности в `/var/result/result.txt`.

## Создание приложений

Создадим 2 приложения.
Был выбран язык C# и технология .NET 7.

Для создания обычных консольных приложений воспользуемся командами:

```sh
dotnet new console -o worker-1
dotnet new console -o worker-2
```

Согласно варианту, программа 1 должна брать все файлы из папки `/var/data`, считывать длину их названия, найти минимальное и переложить его в папку `/var/result`.

[Исходный текст программы worker-1](worker-1/Program.cs)

Согласно варианту программа 2 должна брать строки из папки `/var/data/` с скопированным файлом, пытаться привести их к числам, затем найти минимальное из них.
Далее найти количество вхождений этого числа и результат записать в файл `/var/result/result.txt`.

[Исходный текст программы worker-2](worker-2/Program.cs)

Дополнительно создан файл [.gitignore](.gitignore) для того, чтобы не закоммитить в git ничего лишнего.

## Настройка окружения

Для связи двух приложений воспользуемся следующей схемой:

1. Каталог `./data` должен быть примонтирован в каталог `/var/data` для программы 1.
   Оттуда будут браться исходные данные.
2. Каталог `./result-1` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складываться промежуточные данные.
3. Каталог `./result-1` также должен быть примонтирован в каталог `/var/data` для программы 2.
   Оттуда будут браться промежуточные результаты.
4. Каталог `./result` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складывать результаты финальной обработки.

Для каждой программы были созданы файлы Dockerfile ([программа 1](worker-1/Dockerfile), [программа 2](worker-1/Dockerfile)) с подробным описанием процесса сборки.

Был создан файл [docker-compose.yml](docker-compose.yml), в котором указан манифест для запуска распределённого приложения.

Дополнительно был создан файл [.dockerignore](.dockerignore) и дополнен [.gitignore](.gitignore), чтобы исключить для сборки и коммита всё лишнее.

## Сборка и запуск

В каталог `./data` помещены 4 файла с различной длиной названия и содержимым.
![](image2.PNG)

На выходе, программа должна записать число 2, так как файл с минимальным названием f.txt, в нём минимальное число -100, которое встречается 2 раза.
![](image1.PNG)

Для запуска приложения необходимо ввести команду `docker compose up --build`.
Результат запуска после сборки:

```
[+] Running 2/2
 ✔ Container lab_2-worker-1-1  Created                                                                                                                                                                                                                                0.0s 
 ✔ Container lab_2-worker-2-1  Recreated                                                                                                                                                                                                                              0.1s 
Attaching to lab_2-worker-1-1, lab_2-worker-2-1
lab_2-worker-1-1  | Сервис 1 отработал успешно!
lab_2-worker-1-1 exited with code 0
lab_2-worker-2-1  | Сервис 2 отработал успешно!
lab_2-worker-2-1  | Наименьшее число:= -100 , число вхождений:= 2
lab_2-worker-2-1 exited with code 0
```

В результате в каталоге `./result` создался файл `result.txt` с содержимым `2`, что соответствует входным данным.

Изменение значений в файлах из каталога `./data` также изменяет содержимое в файлах из каталогов `./result-1` и `./result`.